
-- PFT trace decoder
-- 2nd version
-- Decode trace generated by PTM and recovered in the PL through TPIU (Trace Port Interface Unit)

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity pft_decoder_v2 is
    port(
    clk                 : in std_logic;
    reset               : in std_logic;
    data_in             : in std_logic_vector(7 downto 0);
    data_out             : out std_logic_vector(7 downto 0);
    enable                 : in std_logic;
    start_i_sync        : out std_logic;
    stop_i_sync         : in std_logic;
    atomes                : out std_logic_vector(4 downto 0);
    start_bap           : out std_logic;
    stop_bap            : in std_logic;
    start_waypoint      : out std_logic;
    stop_waypoint       : in std_logic
    );
end entity;

architecture archi_behavioral of pft_decoder_v2 is
    -- Different states
    -- allows for different style of encoding: one-hot-zero or binary or grey code or ....
    type state_type is (identify, a_sync, i_sync, atom, bap, waypoint, context_id, wait_state_i_sync,  wait_state_bap, wait_state_waypoint);
    signal state_reg,state_next, temp_state   : state_type := identify; --
    signal data_reg_s, data_reg    : std_logic_vector(7 downto 0);
    signal trace_zero, start_i_sync_s, start_bap_s : std_logic;
    -- PFT Packets headers
    constant i_sync_header : std_logic_vector(7 downto 0) := X"08" ;
    constant atom_header : std_logic_vector(7 downto 0) := "11-----0" ;
    constant bap_header : std_logic_vector(7 downto 0) := "-------1" ;
    constant a_sync_header : std_logic_vector(7 downto 0) :=  X"00";
    constant context_id_header : std_logic_vector(7 downto 0) := X"6E";
    constant waypoint_header : std_logic_vector(7 downto 0) := X"72";
    constant trigger_header : std_logic_vector(7 downto 0) := X"0C";
    constant ignore_header : std_logic_vector(7 downto 0) := X"66";
    -- atom different formats (format_0 is reserved.)
    constant format_0 : std_logic_vector(7 downto 0) := "100000-0";
    constant format_1 : std_logic_vector(7 downto 0) := "100001-0";
    constant format_2 : std_logic_vector(7 downto 0) := "10001--0";
    constant format_3 : std_logic_vector(7 downto 0) := "1001---0";
    constant format_4 : std_logic_vector(7 downto 0) := "101----0";
    constant format_5 : std_logic_vector(7 downto 0) := "11-----0";

    begin
        -----------------------------------------
        -----------------------------------------
        ----- N E X T  S T A T E  L O G I C -----
        -----------------------------------------
        -----------------------------------------
        process(clk)
        begin
            if (clk'event and clk='1') then -- condition better than rising_edge(clk)
                if reset = '1' then
                    state_reg <= identify;
                else
                    state_reg <= state_next;
                end if;
--                end if;
            end if;
        end process;

--        data_reg_s <= data_in;
        process(clk)
        begin
            if (clk'event and clk = '1') then
                if reset = '1' then
                    data_reg_s <= (others => '0');
                else
                    data_reg_s <= data_in;
                end if;
            end if;
        end process;

--process(clk)
--begin
--    if (clk'event and clk = '1') then
--        if reset = '1' then
--            temp_state <= identify;
--        elsif enable = '0' then
--            temp_state <= state_next;
--        end if;
--    end if;
--end process;

    process(data_in)
    begin
        if (data_in = X"00") then
            trace_zero <= '1';
        else
            trace_zero <= '0';
        end if;
    end process;

    -- next state_reg logic
    process (state_reg, data_reg_s, stop_i_sync, stop_bap, stop_waypoint, state_next, enable) --temp_state, is_exception_enabled, isCycleAccurate_enabled) => Timplementation defined (their value did not change dynamically)
    -- local function (Declaring it inside a package would not change anything for the final circuit)
    -- calculates the next state logic according to input a
    variable count : natural := 0;
    function next_state_logic (a : std_logic_vector(7 downto 0)) return state_type is
        begin
            case a is
            when "11000000" |
"11000010" |
"11000100" |
"11000110" |
"11001000" |
"11001010" |
"11001100" |
"11001110" |
"11010000" |
"11010010" |
"11010100" |
"11010110" |
"11011000" |
"11011010" |
"11011100" |
"11011110" |
"11100000" |
"11100010" |
"11100100" |
"11100110" |
"11101000" |
"11101010" |
"11101100" |
"11101110" |
"11110000" |
"11110010" |
"11110100" |
"11110110" |
"11111000" |
"11111010" |
"11111100" |
"11111110" |
--"10000000" | X"80" => Confustion entre bap et i_sync
            "10000010" |
            "10000100" |
            "10000110" |
            "10001000" |
            "10001010" |
            "10001100" |
            "10001110" |
            "10010000" |
            "10010010" |
            "10010100" |
            "10010110" |
            "10011000" |
            "10011010" |
            "10011100" |
            "10011110" |
            "10100000" |
            "10100010" |
            "10100100" |
            "10100110" |
            "10101000" |
            "10101010" |
            "10101100" |
            "10101110" |
            "10110000" |
            "10110010" |
            "10110100" |
            "10110110" |
            "10111000" |
            "10111010" |
            "10111100" |
            "10111110" =>
                return atom;
            when "00000001" |
"00000011" |
"00000101" |
"00000111" |
"00001001" |
"00001011" |
"00001101" |
"00001111" |
"00010001" |
"00010011" |
"00010101" |
"00010111" |
"00011001" |
"00011011" |
"00011101" |
"00011111" |
"00100001" |
"00100011" |
"00100101" |
"00100111" |
"00101001" |
"00101011" |
"00101101" |
"00101111" |
"00110001" |
"00110011" |
"00110101" |
"00110111" |
"00111001" |
"00111011" |
"00111101" |
"00111111" |
"01000001" |
"01000011" |
"01000101" |
"01000111" |
"01001001" |
"01001011" |
"01001101" |
"01001111" |
"01010001" |
"01010011" |
"01010101" |
"01010111" |
"01011001" |
"01011011" |
"01011101" |
"01011111" |
"01100001" |
"01100011" |
"01100101" |
"01100111" |
"01101001" |
"01101011" |
"01101101" |
"01101111" |
"01110001" |
"01110011" |
"01110101" |
"01110111" |
"01111001" |
"01111011" |
"01111101" |
"01111111" |
"11000001" |
"11000011" |
"11000101" |
"11000111" |
"11001001" |
"11001011" |
"11001101" |
"11001111" |
"11010001" |
"11010011" |
"11010101" |
"11010111" |
"11011001" |
"11011011" |
"11011101" |
"11011111" |
"11100001" |
"11100011" |
"11100101" |
"11100111" |
"11101001" |
"11101011" |
"11101101" |
"11101111" |
"11110001" |
"11110011" |
"11110101" |
"11110111" |
"11111001" |
"11111011" |
"11111101" |
"11111111" |
"10000001" |
"10000011" |
"10000101" |
"10000111" |
"10001001" |
"10001011" |
"10001101" |
"10001111" |
"10010001" |
"10010011" |
"10010101" |
"10010111" |
"10011001" |
"10011011" |
"10011101" |
"10011111" |
"10100001" |
"10100011" |
"10100101" |
"10100111" |
"10101001" |
"10101011" |
"10101101" |
"10101111" |
"10110001" |
"10110011" |
"10110101" |
"10110111" |
"10111001" |
"10111011" |
"10111101" |
"10111111"  =>
                return bap;
            when waypoint_header =>
                return waypoint;
            when i_sync_header =>
                return i_sync;
            when a_sync_header =>
                return a_sync;
            when context_id_header =>
                return context_id;
            when others =>
                return identify;
            end case;
        end function;

        begin -- process next_state_logic
        case state_reg is

            when identify =>
                if (enable = '1') then 
                    state_next <= next_state_logic(data_reg_s);
                else
                    state_next <= identify;
                end if;
            -- implement correct header for a_sync ( 5 times "00" and then "80") => A_SYNC)
            -- start counting after one "00" and if count < 5 it is not a_sync
            --       else if count >= 5 and the following packet is X"80" then A_SYNC
            when a_sync =>
                if (enable = '1') then 
                    if (trace_zero = '1') then
                        state_next <= a_sync;
                        --count := count + 1;
                    --elsif (count >= 5 and std_match(data_reg_s,X"80")) then
                        --state_next <= next_state_logic(data_reg_s);
                        --count := 0;
                    else
                        state_next <= next_state_logic(data_reg_s);
                        --count := 0;
                    end if;
                else
                    state_next <= a_sync;
                end if;

            when i_sync =>
                if (enable = '1') then 
                    state_next <= wait_state_i_sync;
                else 
                    state_next <= i_sync;
                end if;

            when atom =>
                if (enable = '1') then 
                    state_next <= next_state_logic(data_reg_s);
                else
                    state_next <= atom;
                end if;

            when bap =>
                if (enable = '1') then 
                    if (stop_bap = '1') then
                        state_next <= next_state_logic(data_reg_s);
                    else
                        state_next <= wait_state_bap;
                    end if;
                else
                    state_next <= bap;
                end if;

            when context_id =>
                if (enable = '1') then 
                    state_next <= next_state_logic(data_reg_s);
                else
                    state_next <= context_id;
                end if;

            when waypoint =>
                if (enable = '1') then 
                    state_next <= wait_state_waypoint;
                else
                    state_next <= waypoint;
                end if;        

            when wait_state_i_sync =>
                if (enable = '1') then
                    if (stop_i_sync = '1') then
                        state_next <= next_state_logic(data_reg_s);
                    else
                        state_next <= wait_state_i_sync;
                    end if;
                else
                    state_next <= wait_state_i_sync;
                end if;

            when wait_state_bap =>
                if (enable = '1') then 
                    if (stop_bap = '1') then
                        state_next <= next_state_logic(data_reg_s);
                    else
                        state_next <= wait_state_bap;
                    end if;
                else
                    state_next <= wait_state_bap;
                end if;

            when wait_state_waypoint =>
                if (enable = '1') then 
                    if (stop_waypoint = '1') then
                        state_next <= next_state_logic(data_reg_s);
                    else
                        state_next <= wait_state_waypoint;
                    end if;
                else
                    state_next <= wait_state_waypoint;
                end if;

            when others =>
                if (enable = '1') then 
                    state_next <= next_state_logic(data_reg_s);
                else
                    state_next <= identify;
                end if;        
        end case;
    end process;

    -----------------------------------------
    -----------------------------------------
    -------- O U T P U T   L O G I C --------
    -----------------------------------------
    -----------------------------------------
    process(state_next, enable)
    begin
        -- initialize signals
        start_i_sync_s <= '0';
        start_bap_s <= '0';
        start_waypoint <= '0';
        case state_next is
            when identify =>
                start_i_sync_s <= '0';
                start_bap_s <= '0';
                start_waypoint <= '0';
                    

            when a_sync =>
            start_i_sync_s <= '0';
            start_bap_s <= '0';
            start_waypoint <= '0';

            when i_sync =>
                if (enable = '1') then 
                    start_i_sync_s <= '1';
                    start_bap_s <= '0';
                    start_waypoint <= '0';
                else 
                    start_i_sync_s <= '0';
                end if;

            when atom =>
            start_i_sync_s <= '0';
            start_bap_s <= '0';
            start_waypoint <= '0';

            when bap =>
                if (enable = '1') then 
                    start_i_sync_s <= '0';
                    start_bap_s <= '1';
                    start_waypoint <= '0';
                end if;

            when waypoint =>
                if (enable = '1') then 
                    start_i_sync_s <= '0';
                    start_bap_s <= '0';
                    start_waypoint <= '1';
                end if;

            when wait_state_waypoint =>
                if (enable = '1') then 
                    start_waypoint <= '1';
                    start_i_sync_s <= '0';
                    start_bap_s <= '0';
                end if;

            when context_id =>
            start_i_sync_s <= '0';
            start_bap_s <= '0';
            start_waypoint <= '0';

            when wait_state_i_sync => -- can decompose into further three states
                if (enable = '1') then 
                    start_i_sync_s <= '1';
                    start_bap_s <= '0';
                    start_waypoint <= '0';
                end if;

            when wait_state_bap =>
                if (enable = '1') then 
                    start_i_sync_s <= '0';
                    start_bap_s <= '1';
                    start_waypoint <= '0';
                end if;

            -- don't forget this to avoid latches (either this or either initialize signals at the beginning of process)
            when others =>
            start_i_sync_s <= '0';
            start_bap_s <= '0';
            start_waypoint <= '0';
        end case;
    end process;
    start_i_sync <= start_i_sync_s;
    start_bap <= start_bap_s;
    data_out <= data_in;
end architecture; -- archi_behavioral
